var __rest = (this && this.__rest) || function (s, e) {
    var t = {};
    for (var p in s) if (Object.prototype.hasOwnProperty.call(s, p) && e.indexOf(p) < 0)
        t[p] = s[p];
    if (s != null && typeof Object.getOwnPropertySymbols === "function")
        for (var i = 0, p = Object.getOwnPropertySymbols(s); i < p.length; i++) {
            if (e.indexOf(p[i]) < 0 && Object.prototype.propertyIsEnumerable.call(s, p[i]))
                t[p[i]] = s[p[i]];
        }
    return t;
};
import React from 'react';
import { FlatList, ScrollView, StyleSheet, View } from 'react-native';
export const PageScrollView = (_a) => {
    var { backgroundColor, contentContainerStyle, children, viewStyle, flatList } = _a, rest = __rest(_a, ["backgroundColor", "contentContainerStyle", "children", "viewStyle", "flatList"]);
    if (flatList)
        return (<FlatList renderItem={null} data={[]} contentContainerStyle={{ flexGrow: 1 }} // Required for footer to grow.
         ListFooterComponentStyle={{ flex: 1 }} // Same
         
        // If ListFooterComponent was function it would for example lose TextInput focus:
        // https://github.com/callstack/react-native-paper/issues/736#issuecomment-455680813
        ListFooterComponent={<View style={[viewStyle, !!backgroundColor && { backgroundColor }]}>{children}</View>} bounces={false} overScrollMode='never' keyboardShouldPersistTaps='handled' nestedScrollEnabled {...rest}/>);
    else
        return (<ScrollView bounces={false} overScrollMode='never' keyboardShouldPersistTaps='handled' contentContainerStyle={[styles.container, contentContainerStyle]} nestedScrollEnabled {...rest}>
      <View style={[styles.view, viewStyle, !!backgroundColor && { backgroundColor }]}>
        {children}
      </View>
    </ScrollView>);
};
const styles = StyleSheet.create({
    container: {
        // https://github.com/facebook/react-native/issues/4099#issuecomment-307541206
        // If using flex: 1, the screen would fill everything as intended, but the scroll
        // wouldn't work.
        flexGrow: 1,
    },
    view: {
        flex: 1,
    },
});
